<template>
    <div>
        <div v-if="payment === 'Card'">
            <div class="payment-block">
                <div class="payment-block__header">
                    Укажите сумму вносимого платежа
                </div>
                <div class="payment-block__body">

                    <div class="form">
                        <label for="payment-block__sum"></label>
                        <div class="input">
                            <input type="tel" v-model="sum" @blur="checkSum">
                            <span class="suffix">₽</span>
                        </div>
                    </div>

                    <div class="summary-info">
                        <div class="title">Осталось погасить по графику</div>
                        <div class="info">
                            <div class="text">
                                Сумма задолженности по графику
                            </div>
                            <div class="sum">
                                {{totalDebt|currency}} ₽
                            </div>
                        </div>
                    </div>

                </div>


                <transition name="fade">
                    <div class="payment-block__repay" v-if="repay">
                        <div class="message message-warn top " v-if="repayStatus === false">
                            <div class="message-icon" v-if="!$interface.isMobile">
                                <SVGIcon xlink="warning-icon" viewBox="0 0 30 30" :fill="$theme.colors.yellow"></SVGIcon>
                            </div>
                            <div class="message-text no-close">
                                <strong>Вы собираетесь полностью погасить займ?</strong>
                                <br>
                                <br>
                                В таком случае при нажатии кнопки «Пересчитать» для Вас будет выполнен перерасчет общей
                                задолжности в соответсвии с процентами на сегодняшний день. Дабы не состоялась переплата
                                за погашение процентов согласно полному графику ежемесячных платежей.
                            </div>
                        </div>

                        <div v-else class="message message-info top">
                            <div class="message-icon" v-if="!$interface.isMobile">
                                <SVGIcon xlink="info-icon" viewBox="0 0 30 30" :fill="$theme.colors.blue" ></SVGIcon>
                            </div>
                            <div class="message-text no-close">
                                <strong>Сумма долга пересчитана для полного погашения задолженности</strong>
                                <br><br>
                                Для возврата к выбору суммы оплаты нажмите «Отмена»
                            </div>
                        </div>
                    </div>
                </transition>

                <div class="payment-block__footer">
                    <div class="services" v-if="haveAdditionalService && ($interface.isMobile && !repay)" :class="{disabled: repay}">
                        <div v-for="service in additionalService" :key="service.id" class="ui-checkbox service">
                            <ui-checkbox v-model="service.selected" @change="updateAdditionalSum"></ui-checkbox>
                            <p>
                                <strong>{{service.title}} за {{service.price|currency}} ₽</strong>
                                {{service.description}}

                                <span class="link block"
                                      @click="openPopup(service.document_url)">{{service.document_title}}</span>
                            </p>
                        </div>
                    </div>

                    <div class="pos__payment-info">
                        <div class="button" @click="payHandler">
                            <div class="sum" v-if="repay && !repayStatus">Пересчитать</div>
                            <div class="sum" v-else="repay">{{sum|currency}} ₽</div>
                            <div class="text">
                                <span v-if="!repay || repayStatus">{{repay && !repayStatus ? 'Пересчитать' : 'Оплатить'}}</span>
                                <SVGIcon :xlink="repay && !repayStatus? 'recount' : 'collapse-20'" view-box="0 0 20 20" :rotate="repay && !repayStatus ? 0 :-90" fill="#ffffff"></SVGIcon>
                            </div>
                        </div>
                        <div class="link bold center" @click="repay ? customSum = 0 : payment = ''">{{repay && !repayStatus ? 'Отмена' : 'Другой способ погашения'}}</div>
                    </div>
                </div>
            </div>
            <payment-checkbox-list @set-sales="setSales"></payment-checkbox-list>
        </div>
        <div v-else-if="payment">
            <component :is="paymentComponent" component="POS"></component>
        </div>
        <div v-else>
            <div class="payment-block">
                <div class="payment-block__header">
                    Выберите способ погашения
                </div>
                <div class="payment-block__body payment-methods">
                    <div v-for="method in paymentMethods" :key="method.shortname" class="method" @click="payment = method.component">

                            <img :src="`/lk/static/img/pay/${method.shortname}.png`"
                                 :alt="method.description">
                            <div class="divider"></div>
                            {{method.description}}
                    </div>

                    <transition name="fade">
                        <div v-if="methodsLoadError" class="message message-warn" style="margin-top: 50px;">
                            <div class="message-icon" v-if="$interface.isMobile === false">
                                <SVGIcon xlink="warning-icon" viewBox="0 0 30 30"
                                         :fill="$theme.colors.yellow"></SVGIcon>
                            </div>
                            <div class="message-text">Некоторые способы оплаты сейчас недоступны и не отображены.</div>
                            <!--                    <div class="message-close" @click="getPaymentMethods">-->
                            <!--                        <SVGIcon xlink="refresh" :fill="$theme.colors.yellow" viewBox="0 0 22 22"></SVGIcon>-->
                            <!--                    </div>-->
                        </div>
                    </transition>
                </div>

            </div>
        </div>
    </div>
</template>

<script>
    import PaymentCheckboxList from './components/payment-checkbox-list.vue';
    import SVGIcon from '@/components/SVGIcon';
    import PosScheduleMixin from './mixins/schedule';

	import Sberbank from '@/components/Pay/PaymentMethods/Sberbank'
	import Phone from '@/components/Pay/PaymentMethods/Phone'
	import YandexWallet from '@/components/Pay/PaymentMethods/YandexWallet'
	import CardForm from '@/components/Pay/PaymentMethods/Card'

	export default {
        name: 'pos-page-payment',
        mixins: [PosScheduleMixin],
        components: {
			PaymentCheckboxList,
            SVGIcon,

            //payment methods
			Sberbank,
			Phone,
			YandexWallet,
			CardForm,
        },

        computed: {
        	totalDebt () {
        		let overdueSum = this.debtSum.percent + this.debtSum.penalties + this.debtSum.body;
        		let scheduleSum = this.$POS.schedule.reduce((a, schedule) => {
        			if(!schedule.isPaid) {
        				return a + schedule.amount;
                    }

        			return a;
                }, 0);

        		return overdueSum + scheduleSum;
            },

        	additionalService () {
        		return this.$store.getters['ADDITIONAL_SERVICES_GET_LIST'].filter((service) => {
        			return [3].includes(service.location_int);
                })
            },

            haveAdditionalService () {
        		return Boolean(this.additionalService.length);
            },

            sum: {
        		get () {
        			if(this.repay && this.repaySum) {
        				return this.repaySum;
                    }

        			return this.customSum ? this.customSum : this.computedSum + this.additionalSum;
                },

                set (sum) {
        			this.customSum = sum;
                }
            },

			computedSum () {
        		let sum = 0;
        		this.$POS.schedule.forEach((schedule) => {
        			if(schedule.isOverdue) {
        				schedule.sales.forEach((sale) => {
        					if(sale.selected) {
        						sum += sale.amount - sale.paid_amount;
                            }
                        })
                    }
                });

        		this.currentPay.sales.forEach((sale) => {
        			if(sale.selected) {
        				sum += sale.amount - sale.paid_amount;
                    }
                });

        		return sum;
            },


			paymentMethods () {
        		return  [
					{id: 0, shortname: 'card', description: 'Банковская карта', component: 'Card'},
					{id: 1, shortname: 'sber', description: 'Сбербанк онлайн', component: 'Sberbank'},
					{id: 3, shortname: 'yandex', description: 'Кошелек Яндекс.Деньги', component: 'YandexWallet'},
					{id: 4, shortname: 'phone', description: 'Мобильный телефон', component: 'Phone'}
				]
            },

			paymentComponent () {
        		return this.$options.components[this.payment]
            },

            repay () {
        		return this.customSum >= this.totalDebt;
            }
        },

        data () {
        	return {
        		customSum: 0,
				additionalSum: 0,
                payment: '',
				methodsLoadError: false,
                repayStatus: false,
                repaySum: 0,
                selectedSales: [],
            }
        },

        created () {
        	this.AJAX_LOADING(true);
        	Promise.all([
        		this.$store.dispatch('ADDITIONAL_SERVICES_LOAD_LIST'),
                this.getPaymentMethods(),
            ]).finally(() => {
        		this.AJAX_LOADING(false);
            });
        },


        methods: {
        	updateSum () {

            },

			updateAdditionalSum () {
				this.additionalSum = this.$store.getters['ADDITIONAL_SERVICES_GET_LIST'].reduce((a, service) => {
					if(service.selected && [3].includes(service.location_int)) {
						return a + parseFloat(service.price);
					}
					return a;
				}, 0);
            },


            getPaymentMethods () {
        		return this.$store.dispatch('PAYMENT_GET_METHODS').then(() => {
					this.methodsLoadError = false;
                }).catch((e) => {
					this.methodsLoadError = true;
				})
            },

            payHandler () {
        		if(this.repay && !this.repaySum) {
        			this.recountDebt();
                } else {
        			this.doPay();
                }
            },


            recountDebt () {
				this.AJAX_LOADING({isShow: true, waitingTitle: 'Подождите...', caption: 'Идет пересчет процентов', name: 'rootFixed'});
				this.$store.dispatch('POS_RECOUNT_DEBT').then((sum) => {
                    this.repayStatus = true;
                    this.repaySum = sum;

                    this.resetAdditionalServices();
                }).catch((e) => {
                	this.$toastr.error('Ошибка при пересчете. Попробуйте еще раз', 'Ошибка сервера');
                }).finally(() => {
                	this.AJAX_LOADING(false);
                })
            },


            doPay () {
        		this.$store.commit('SET_PAYMENT', {
        			type: 'POS_PAYMENT',
                    amount: this.sum,
                    data: {
        				type: 6,
                        ids: this.selectedSales.filter((sale) => {
                            return sale.selected;
                        }).map((sale) => {
                            return sale.id
                        })
                    },
                    additionalService: this.additionalService.map((/**iAdditionalService**/service) => {
                        return {
                            name:  service.title,
                            price: service.price
                        }
                    })
                });

        		this.payment = 'CardForm';
            },


			setSales(/**[iPosSale]**/ sales) {
                this.selectedSales = sales;
            },


			resetAdditionalServices () {
        		this.additionalService.forEach((service) => {
        			this.$store.commit('ADDITIONAL_SERVICE_FALSE', service.id);
                });
            },

			checkSum () {
        		if(isNaN(parseFloat(this.sum))) {
        			this.sum = 0;
        			this.$toastr.warning('Была введена некорректная сумма. Проверьте сумму платежа.', 'Внимание!')
                }
            }
        }
	};
</script>

<style scoped>

</style>
